--- old/usr/src/lib/pkcs11/pkcs11_softtoken/common/softSlotToken.c	Fri Jul  6 15:55:13 2018
+++ new/usr/src/lib/pkcs11/pkcs11_softtoken/common/softSlotToken.c	Fri Jul  6 15:55:13 2018
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2018, Joyent, Inc.
  */
 
 #include <strings.h>
@@ -337,9 +338,12 @@
 			pInfo->flags |= CKF_USER_PIN_TO_BE_CHANGED;
 	}
 
-	if (ks_cryptpin)
-		free(ks_cryptpin);
+	if (ks_cryptpin != NULL) {
+		size_t cplen = strlen(ks_cryptpin) + 1;
 
+		freezero(ks_cryptpin, cplen);
+	}
+
 	/* Provide information about a token in the provided buffer */
 	(void) strncpy((char *)pInfo->label, SOFT_TOKEN_LABEL, 32);
 	(void) strncpy((char *)pInfo->manufacturerID, SOFT_MANUFACTURER_ID, 32);
